<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="theme-color" content="#000000" />
    <meta name="description" content="Blurt Mobile App" />
    <title>Blurt Mobile App</title>
  </head>
  <body>
    <noscript>You need to enable JavaScript to run this app.</noscript>
    <script src="https://cdn.jsdelivr.net/npm/@blurtfoundation/blurtjs/dist/blurt.min.js"></script>
    <script>
      function validateKey(accountName, postingKey, server) {
        blurt.api.setOptions({ url: server, useAppbaseApi: true });
        console.log("In here before async");
        blurt.api.getAccounts([accountName], function (err, accounts) {
          if (err) {
            console.log("Error: ", err);
            replyToNative({
              type: "validateKey",
              valid: false,
              accountName: accountName,
              error: err.message,
            });
          } else {
            console.log("In here after async");
            console.log("Accounts: ", accounts);
            const pubWif = accounts[0].posting.key_auths[0][0];
            try {
              const Valid = blurt.auth.wifIsValid(postingKey, pubWif);
              console.log(`is valid ${Valid}`);
              replyToNative({
                type: "validateKey",
                valid: Valid,
                accountName: accountName,
                error: "",
              });
            } catch (err) {
              replyToNative({
                type: "validateKey",
                valid: false,
                accountName: accountName,
                error: err.message,
              });
            }
          }
        });
      }

      function upvote(
        accountName,
        postingKey,
        server,
        author,
        permlink,
        weight
      ) {
        blurt.api.setOptions({ url: server, useAppbaseApi: true });
        console.log("In here before async");
        blurt.broadcast.vote(
          postingKey,
          accountName,
          author,
          permlink,
          weight,
          function (err, result) {
            console.log("In here after async");
            console.log(err, result);
            if (err) {
              console.log("Error: ", err);
              replyToNative({
                type: "upvote",
                valid: false,
                accountName: accountName,
                error: err.message,
              });
            } else {
              replyToNative({
                type: "upvote",
                valid: true,
                accountName: accountName,
                error: "",
              });
            }
          }
        );
      }

      function getMetaData(summary, tags, platform, thumbImage) {
        let newSummary = atob(summary);
        newSummary = decodeURIComponent(escape(newSummary));
        return {
          tags: tags.split(" "),
          app: platform,
          format: "markdown",
          description: newSummary,
          image: [thumbImage],
        };
      }

      function comment(
        accountName,
        postingKey,
        server,
        permlink,
        title,
        body,
        summary,
        tags,
        platform,
        pAuthor,
        pPermlink,
        thumbImage
      ) {
        blurt.api.setOptions({ url: server, useAppbaseApi: true });
        console.log("In here before async comment");
        console.log(`body is ${body}`);
        console.log(`atob body is ${atob(body)}`);
        console.log(`utf8 body is ${decodeURIComponent(escape(atob(body)))}`);
        let newBody = atob(body);
        newBody = decodeURIComponent(escape(newBody));
        blurt.broadcast.comment(
          postingKey,
          pAuthor,
          pPermlink,
          accountName,
          permlink,
          title,
          newBody,
          getMetaData(summary, tags, platform, thumbImage),
          function (err, result) {
            console.log("In here after async comment");
            console.log(err, result);
            if (err) {
              console.log("Error: ", err);
              replyToNative({
                type: "comment",
                valid: false,
                accountName: accountName,
                error: err.message,
              });
            } else {
              console.log(`Success response: ${JSON.stringify(result)}`);
              replyToNative({
                type: "comment",
                valid: true,
                accountName: accountName,
                error: "",
              });
            }
          }
        );
      }

      function updateFollowInfo(accountName, actionAccount, actionType) {
        blurt.api.getChainProperties(function (err, result) {
          console.log(err, result);
          if (err) {
            replyToNative({
              type: "updateFollowInfo",
              valid: false,
              accountName: accountName,
              error: err.message,
            });
            return;
          } else {
            let what;
            if (actionType === "follow") {
              type = ["blog"];
            } else if (actionType === "unfollow") {
              type = [];
            } else if (actionType === "mute") {
              type = ["ignore"];
            } else if (actionType === "unmute") {
              type = [];
            } else {
              type = [];
            }
            const json = ["follow", { accountName, actionAccount, what }];
            let operation = {
              id: "follow",
              required_posting_auths: [accountName],
              json: JSON.stringify(json),
            };
            let size = JSON.stringify(operation).replace(
              /[\[\]\,\"]/g,
              ""
            ).length;
            let bFee = parseFloat(result.bandwidth_kbytes_fee);
            let fFee = parseFloat(result.operation_flat_fee);
            let bw_fee = Math.max(0.001, ((size / 1024) * bFee).toFixed(3));
            let fee = (fFee + bw_fee).toFixed(3);
            replyToNative({
              type: "updateFollowInfo",
              valid: true,
              accountName: accountName,
              error: `fee: ${fee}`,
            });
          }
        });
      }

      // actionType = 'follow', 'unfollow', 'mute', 'unmute'
      function updateFollow(
        accountName,
        postingKey,
        actionAccount,
        actionType
      ) {
        let type;
        if (actionType === "follow") {
          type = ["blog"];
        } else if (actionType === "unfollow") {
          type = [];
        } else if (actionType === "mute") {
          type = ["ignore"];
        } else if (actionType === "unmute") {
          type = [];
        } else {
          type = [];
        }
        const json = [
          "follow",
          { follower: accountName, following: actionAccount, what: type },
        ];
        blurt.broadcast.customJson(
          postingKey,
          [],
          [accountName],
          "follow",
          JSON.stringify(json),
          function (err, result) {
            if (err) {
              replyToNative({
                type: "updateFollow",
                valid: false,
                accountName: accountName,
                error: err.message,
              });
              return;
            } else {
              replyToNative({
                type: "updateFollow",
                valid: true,
                accountName: accountName,
                error: "",
              });
            }
          }
        );
      }

      function claimRewards(accountName, postingKey, rewardBlurt, rewardVests, server) {
        blurt.api.setOptions({ url: server, useAppbaseApi: true });
        blurt.broadcast.claimRewardBalance(
          postingKey, accountName, rewardBlurt, rewardVests,
          function (err, result) {
            console.log(err, result);
            if (err) {
              replyToNative({
                type: "claimRewards",
                valid: false,
                accountName: accountName,
                error: err.message,
              });
              return;
            } else {
              replyToNative({
                type: "claimRewards",
                valid: true,
                accountName: accountName,
                error: "",
              });
            }
          }
        );
      }

      function replyToNative(result) {
        console.log(`Result is ${JSON.stringify(result)}`);
        window.webkit.messageHandlers.blurt.postMessage(result);
        // Android.postMessage(JSON.stringify(result));
      }
    </script>
  </body>
</html>
